<!-- 委托方意见登记表列表 -->
<script name="SuggestFormList" lang="ts" setup>
import { ElMessage, ElMessageBox } from 'element-plus'
import type { DateModelType } from 'element-plus'
import dayjs from 'dayjs'
import type{ ICustomerSuggestInfo, IListQuery } from './customer-suggest'
import SuggestApprovalDialog from './suggestApprovalDialog.vue'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { deleteSuggestFormDraft, deleteSuggestFormRevoked, getSuggestFormList } from '@/api/resource/suggestForm'
import { getDictByCode } from '@/api/system/dict'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import type { IDictType } from '@/commonInterface/resource-interface'

// 定义常量
const buttonBoxActive = 'suggestFormApproval' // 存储在sessionstorage里面的字段名，用于记录右上角buttonbox点击状态
const flowFormId = 'zyglwtfyjdjb' // 资源管理 - 委托方意见登记表

const { proxy } = getCurrentInstance() as any
const router = useRouter()

// 选中的审批状态按钮
const active = ref('')
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const approvalStatusList = ref<String[]>([
  '全部', '已审批', '草稿箱', '待审批', '审批中', '已通过', '未通过', '已取消', '我的审批单',
])

// 弹窗子组件
const apprDial = ref()

// 查询条件
const searchQuery = ref<IListQuery>({
  formNo: '', // 通知单编号
  customerName: '',
  customerDeptName: '',
  createUserName: '', // 创建人名字
  createTimeStart: '', // 创建时间-起始
  createTimeEnd: '', // 创建时间-结束
  approvalStatus: active.value, // 审批状态
  formId: flowFormId, // 表单id（流程定义对应的表单id，等价于业务id），此处为固定值
  offset: 1,
  limit: 20,
})
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const total = ref(0) // 数据条数
const loadingTable = ref(false) // 表格loading

// 表头
const columns = ref<TableColumn[]>([
  { text: '表单编号', value: 'formNo', align: 'center', width: '180' },
  { text: '意见反馈单位', value: 'customerName', align: 'center' },
  { text: '意见反馈部门', value: 'customerDeptName', align: 'center' },
  { text: '创建人', value: 'createUserName', align: 'center', width: '150' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '180' },
])
const suggestList = ref<Array<ICustomerSuggestInfo>>([]) // 表格数据

const reset = () => {
  searchQuery.value = {
    formNo: '', // 委托方编号
    customerName: '', // 委托方名字
    customerDeptName: '', // 联系人
    createUserName: '',
    createTimeStart: '', // 创建时间-起始
    createTimeEnd: '', // 创建时间-结束
    approvalStatus: active.value, // 审批状态
    formId: flowFormId, // 表单id（流程定义对应的表单id，等价于业务id），此处为固定值
    offset: 1,
    limit: 20,
  }
  dateRange.value = ['', '']
  fetchData(true)
}

const searchList = () => {
  fetchData(true)
}

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    searchQuery.value.offset = 1
  }
  getSuggestFormList(searchQuery.value).then((response) => {
    if (response.code === 200) {
      suggestList.value = response.data.rows

      total.value = parseInt(response.data.total)
    }
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.value.limit = val.size
  }
  if (val && val.page) {
    searchQuery.value.offset = val.page
  }
  fetchData(true)
}

const addSuggestForm = () => {
  router.push({
    query: {
      type: 'create',
    },
    path: 'suggestForm/detail',
  })
}

const detail = (row: ICustomerSuggestInfo) => {
  if (active.value === '0') {
    // 全部时 查看和打印文件流
    router.push({
      query: {
        id: row.id,
      },
      path: 'suggestForm/approved/detail',
    })
  }
  else if (active.value === '1') {
    // 草稿箱 状态下的查看 可以编辑
    sessionStorage.setItem('suggestFormInfo', JSON.stringify(row))
    router.push({
      query: {
        type: 'update',
        id: row.id,
        status: active.value,
      },
      path: 'suggestForm/detail',
    })
  }
  else {
    sessionStorage.setItem('suggestFormInfo', JSON.stringify(row))
    router.push({
      query: {
        type: 'detail',
        id: row.id,
        status: active.value,
      },
      path: 'suggestForm/detail',
    })
  }
}

// 删除
const deleteSuggestById = (row: ICustomerSuggestInfo) => {
  ElMessageBox.confirm(
    `确认删除意见登记表 ${row.formNo} 吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    if (active.value === '0' || active.value === '1') {
      // 全部 及 草稿箱 中删除
      deleteSuggestFormDraft({ id: row.id }).then((res) => {
        if (res.code === 200) {
          ElMessage.success(`意见登记表 ${row.formNo} 删除成功`)
          fetchData(true)
        }
        else {
          ElMessage.error(`意见登记表 ${row.formNo} 删除失败：${res.message}`)
        }
      })
    }
    else if (active.value === '6') {
      // 已取消 中删除
      deleteSuggestFormRevoked({ id: row.id }).then((res) => {
        if (res.code === 200) {
          ElMessage.success(`意见登记表 ${row.formNo} 删除成功`)
          fetchData(true)
        }
        else {
          ElMessage.error(`意见登记表 ${row.formNo} 删除失败：${res.message}`)
        }
      })
    }
  })
}

// 审批按钮点击切换事件
const changeCurrentButton = (val: string) => {
  active.value = val // 此时的tab
  sessionStorage.setItem(buttonBoxActive, val) // 记录tab状态

  reset() // 刷新
}

// 流程审批-同意
const approvalAgreeHandler = (row: ICustomerSuggestInfo) => {
  apprDial.value.initDialog('agree', row.id, row.taskId, '')
}

// 流程审批-拒绝
const approvalRefuseHandler = (row: ICustomerSuggestInfo) => {
  apprDial.value.initDialog('refuse', row.id, row.taskId, '')
}

// 取消（撤回审批单）
const revokeApprById = (row: ICustomerSuggestInfo) => {
  apprDial.value.initDialog('revoke', row.id, row.taskId, row.processId)
}

// 流程操作之后刷新
const afterApprovalHandler = () => {
  fetchData(true)
}

// 初始化流程审批状态按钮
const getApprovalStatusDict = async () => {
  await getDictByCode('approvalStatus').then((res) => {
    if (res.code === 200) {
      res.data.forEach((item: IDictType) => {
        if (approvalStatusList.value.includes(item.name)) {
          menu.value.push({
            name: item.name,
            id: `${item.value}`,
          })
        }
      })
    }
  })
}

const getDict = async () => {
  await getApprovalStatusDict()
}

watch(dateRange, (val) => {
  if (val) {
    searchQuery.value.createTimeStart = dayjs(val[0]).format('YYYY-MM-DD') === 'Invalid Date' ? '' : dayjs(val[0]).format('YYYY-MM-DD')
    searchQuery.value.createTimeEnd = dayjs(val[1]).format('YYYY-MM-DD') === 'Invalid Date' ? '' : dayjs(val[1]).format('YYYY-MM-DD')
  }
  else {
    searchQuery.value.createTimeStart = ''
    searchQuery.value.createTimeEnd = ''
  }
})

onMounted(async () => {
  await getDict()
  if (sessionStorage.getItem(buttonBoxActive) !== undefined && sessionStorage.getItem(buttonBoxActive) !== null) {
    active.value = sessionStorage.getItem(buttonBoxActive)!
  }
  else {
    active.value = '0' // 全部
  }
})
</script>

<template>
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="searchList" @clear="reset">
      <search-item>
        <el-input v-model="searchQuery.formNo" placeholder="登记表编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.customerName" placeholder="意见反馈单位" clearable />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.customerDeptName" placeholder="意见反馈部门" clearable />
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.createUserName" placeholder="创建人" clearable />
      </search-item>
      <search-item>
        <el-date-picker v-model="dateRange" type="daterange" start-placeholder="创建时间（开始）" end-placeholder="创建时间（结束）" />
      </search-item>
    </search-area>

    <!-- 表格数据展示 -->
    <table-container>
      <!-- 表头区域 -->
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/resource/customer/suggestForm/add') && active === '0'" icon="icon-add" title="新建" @click="addSuggestForm" />
      </template>

      <!-- 表格区域 -->
      <normal-table
        :data="suggestList" :total="total" :columns="columns"
        :query="{ limit: searchQuery.limit, offset: searchQuery.offset }"
        :list-loading="loadingTable"
        @change="changePage"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column fixed="right" label="操作" align="center" width="130">
            <template #default="{ row }">
              <el-button v-if="active === '0'" size="small" type="primary" link @click="detail(row)">
                查看
              </el-button>

              <el-button v-else size="small" type="primary" link @click="detail(row)">
                查看2
              </el-button>

              <el-button v-if="(active === '0' || active === '1' || active === '6') && proxy.hasPerm(`/resource/customer/suggestForm/del`)" size="small" type="danger" link @click="deleteSuggestById(row)">
                删除
              </el-button>

              <template v-if="active === '2'">
                <el-button size="small" type="primary" link @click="approvalAgreeHandler(row)">
                  同意
                </el-button>
                <el-button size="small" type="danger" link @click="approvalRefuseHandler(row)">
                  拒绝
                </el-button>
              </template>
              <template v-if="active === '3'">
                <el-button size="small" type="info" link @click="revokeApprById(row)">
                  取消
                </el-button>
              </template>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>

    <!-- 审批单弹窗 -->
    <suggest-approval-dialog ref="apprDial" @on-success="afterApprovalHandler" />

    <!-- 右上角按钮集合 -->
    <button-box :active="active" :menu="menu" @change-current-button="changeCurrentButton" />
  </app-container>
</template>
